"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
class CommandLoader {
    constructor(commander) {
        this._path = __dirname + "/commands";
        this._commands = [];
        this._commander = commander;
    }
    loadCommands() {
        let loadDir = fs.readdirSync(this._path);
        for (let file of loadDir) {
            let module = require(this._path + "/" + file).default;
            let command = new module();
            command.setConfiguration();
            let com = this._commander.command(command.command);
            command.options.forEach(v => com.option(v));
            com.description(command.description);
            com.action(command.action.bind(command));
        }
    }
}
exports.CommandLoader = CommandLoader;
