"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("../command");
const chalk_1 = require("chalk");
const copynode = require("copy-node-modules");
const DIR = process.cwd();
class CopyNode extends command_1.Command {
    action(...args) {
        let command = args.pop();
        console.log(chalk_1.default.red("Working dir: ") + DIR);
        console.log(chalk_1.default.green("-- COPY NODE MODULES --"));
        this.pack(command);
    }
    checkPathStart(path) {
        return path.startsWith("/") || path.startsWith(".");
    }
    pack(obj) {
        return __awaiter(this, void 0, void 0, function* () {
            let input = obj.input || "/";
            let out = obj.output || input + "dist";
            let outPath = !this.checkPathStart(out) ? DIR + "/" + out : out;
            let inPath = !this.checkPathStart(input) ? DIR + "/" + input : input;
            let filter = (v) => {
                let index = v.indexOf("node_modules");
                let secondIndex = v.indexOf("node_modules", index + 1);
                return (secondIndex == -1);
            };
            copynode(input, out, { devDependencies: false, filter: filter }, function (err, results) {
                if (err) {
                    console.error(err);
                    return;
                }
                for (var i in results) {
                    console.log("package name: " +
                        results[i].name +
                        ", version: " +
                        results[i].version);
                }
            });
        });
    }
    setConfiguration() {
        this.command = "copy-modules";
        this.options = ["-o, --output <value>", "-i, --input <value>"];
        this.description =
            "Quickly copys node modules from target package.json to the output directory.";
    }
}
exports.default = CopyNode;
