"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("../command");
const chalk_1 = require("chalk");
const yaml_1 = require("../util/yaml");
const DIR = process.cwd();
class YalmTemplater extends command_1.Command {
    action(...args) {
        return __awaiter(this, void 0, void 0, function* () {
            let command = args.pop();
            let file = args.shift();
            console.log(chalk_1.default.red("Working dir: ") + DIR);
            console.log(chalk_1.default.green("-- Checking: " + chalk_1.default.bold(file) + " --"));
            const check = yield yaml_1.YamlUtil.isValidYamlFile(file);
            if (!check) {
                console.log(chalk_1.default.red("Not VALID!"));
                process.exit(1);
            }
            else {
                console.log(chalk_1.default.green("Valid!"));
            }
        });
    }
    setConfiguration() {
        this.command = "yaml-validator <file>";
        this.description = "Validates the given yaml file";
        this.options = [];
    }
}
exports.default = YalmTemplater;
