"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const fs = require("fs");
const yamlLint = require("yaml-lint");
class YamlUtil {
    static isValidYaml(yamlData) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            try {
                let validate = yield yamlLint.lint(yamlData);
                resolve(true);
            }
            catch (ex) {
                console.log(chalk_1.default.red("Error: ") + ex.name);
                console.log(chalk_1.default.red("Message: "), ex.message);
                resolve(false);
            }
        }));
    }
    static isValidYamlFile(file) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            try {
                let fileData = fs.readFileSync(file, "UTF-8");
                let validate = yield yamlLint.lint(fileData);
                resolve(true);
            }
            catch (ex) {
                console.log(chalk_1.default.red("Error: ") + ex.name);
                console.log(chalk_1.default.red("Message: "), ex.message);
                resolve(false);
            }
        }));
    }
}
exports.YamlUtil = YamlUtil;
